# Generator selections
This folder contains the scripts and notebooks used for selecting the LLM for review generation.

## `test_generators.py` and `job.sh`

The scripts `test_generators.py` is used to generate a set of reviews for a selection of different prompts. It takes the follwoing arguments:
- `model_id`: Huggingface ID of the LLM that should be used for review generation.
- `setting_name`: Name of the setting for which reviews will be generated. A setting is defined by the configuration files in the path `$results_dir/$setting_name`:
    - `config.toml`: contains the LLM parameters
    - `instruction_templates.toml`: contains the prompt templates
    - `prompt_configs.toml`: contains different values to be inserted into the prompt templates for which then reviews are generated.
- `--results_dir` (optional, default: `./results`): directory where configurations are stored and where the generated review should be stored.

`job.sh` is used to submit compute jobs to the RWTH cluster to execute `test_generators.py` for different candidate LLMs. To submit the jobs, use the following commands:
```
export SETTING_NAME=${setting name}
sbatch -A ${RWTH Cluster account name} -o ${path for logfile} --export=SETTING_NAME job_openai.sh
```

Where `${setting name}` corresponds to the respective parameter of `test_generators.py`. See the SLURM docs for information on how to format the [logfile path](https://slurm.schedmd.com/sbatch.html#OPT_output).

## `extract_json.py`
This script is used to extract valid json from the text generated by th LLMs.

## `evaluation.ipynb`
In this notebook the reviews generated by the different candidate LLMs are compared.